
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C169FA  ; location in v1.0
;org $C169F7  ; location in v1.1
C169FA:	JSL long_draw
;C169FA:	TAX  ; JSL replaces all three of these instructions
;C169FB:	TDC
;C169FC:	SEP #$20

org $C1FFFC
helper:
C1FFFC:	JSR $66F3  ; draw the input tile
C1FFFF:	RTL
;C1FFFC:	SBC $FFFFFF,X  ; used to mean four FFs; the two instructions above replace this

org $C35EF8  ; location without Brushless Sketch
;org $C35EF5  ; location with Brushless Sketch
C35EF8:	JSR short_draw
;C35EF8:	LDY #$0007  ; JSR replaces this

org $C3FF93
;padbyte $FF : pad $C40000
long_draw:
C3FF93:	PHA  ; command name index
C3FF94:	SEP #$20  ; 8-bit A
C3FF96:	LDA $62CA  ; get current character
C3FF99:	ASL A
C3FF9A:	TAX
C3FF9B:	LDA $01,S  ; command name index
C3FF9D:	BEQ long_fight  ; branch if Fight
C3FF9F:	CMP #$9A  ; check if command is Jump
C3FFA1:	BNE exit1  ; exit if not
C3FFA3:	LDA $3C44,X  ; Battle FX 1
C3FFA6:	ASL A  ; Dragon Horn check
C3FFA7:	BRA long_test_relic

org $C3FFC4
long_fight:
C3FFC4:	LDA $3C58,X  ; Relic FX
C3FFC7:	LSR A  ; Offering check

long_test_relic:
C3FFC8:	BCC exit1  ; exit if Relic check failed
C3FFCA:	LDA #$97  ; X
C3FFCC:	JSL helper  ; draw X
C3FFD0:	LDA #$FE  ; ' '
C3FFD2:	JSR helper  ; draw ' '; command changes from Fight to X Fight
C3FFD6:	DEC $10  ; decrement counter twice
C3FFD8:	DEC $10  ; draw 5 more tiles instead of 7

exit1:
C3FFDA:	PLX  ; restore command name index
C3FFDB:	TDC  ; clear high byte of A
C3FFDC:	RTL

short_draw:
C3FFDD:	LDY #$0007  ; set to draw 7 tiles
C3FFE0:	TAX  ; command name index
C3FFE1:	BNE short_check_jump  ; exit if not Fight
C3FFE3:	LDA $11D8  ; Relic FX
C3FFE6:	LSR A  ; Offering check
C3FFE7:	BRA short_test_relic

short_check_jump:
C3FFE9:	CMP #$9A  ; check if command is Jump
C3FFEB:	BNE exit2  ; exit if not
C3FFED:	LDA $11D6  ; Battle FX 1
C3FFF0:	ASL A  ; Dragon Horn check

short_test_relic:
C3FFF1:	BCC exit2  ; exit if Relic check failed
C3FFF3:	LDA #$97  ; X
C3FFF5:	STA $2180  ; draw X
C3FFF8:	LDA #$FE  ; ' '
C3FFFA:	STA $2180  ; draw ' '; command changes from Fight to X Fight
C3FFFD:	DEY  ; decrement counter twice
C3FFFE:	DEY  ; draw 5 more tiles instead of 7

exit2:
C3FFFF:	RTS