
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C169FA  ; location in v1.0
;org $C169F7  ; location in v1.1
C169FA:	JSL long_draw
;C169FA:	TAX  ; JSL replaces all three of these instructions
;C169FB:	TDC
;C169FC:	SEP #$20

org $C1FFFC
helper:
C1FFFC:	JSR $66F3  ; draw the input tile
C1FFFF:	RTL
;C1FFFC:	SBC $FFFFFF,X  ; used to mean four FFs; the two instructions above replace this

org $C35EF8  ; location without Brushless Sketch
;org $C35EF5  ; location with Brushless Sketch
C35EF8:	JSR short_draw
;C35EF8:	LDY #$0007  ; JSR replaces this

org $C3FFC1
;padbyte $FF : pad $C40000
long_draw:
C3FFC1:	TAX  ; command name index
C3FFC2:	SEP #$20  ; 8-bit A
C3FFC4:	BNE exit1  ; exit if command isn't Fight
C3FFC6:	PHX
C3FFC7:	LDA $62CA  ; get current character
C3FFCA:	ASL A
C3FFCB:	TAX
C3FFCC:	LDA $3C58,X  ; Relic effects
C3FFCF:	PLX
C3FFD0:	AND #$01  ; Offering?
C3FFD2:	BEQ exit1  ; exit if not
C3FFD4:	LDA #$97  ; X
C3FFD6:	JSL helper  ; draw X
C3FFDA:	LDA #$FE  ; ' '
C3FFDC:	JSR helper  ; draw ' '; command changes from Fight to X Fight
C3FFE0:	DEC $10  ; decrement counter twice
C3FFE2:	DEC $10  ; draw 5 more tiles instead of 7

exit1:
C3FFE4:	TDC  ; clear high byte of A
C3FFE5:	RTL

short_draw:
C3FFE6:	LDY #$0007  ; set to draw 7 tiles
C3FFE9:	TAX  ; command name index
C3FFEA:	BNE exit2  ; exit if not Fight
C3FFEC:	LDA $11D8  ; Relic effects
C3FFEF:	AND #$01  ; Offering?
C3FFF1:	BEQ exit2  ; exit if not
C3FFF3:	LDA #$97  ; X
C3FFF5:	STA $2180  ; draw X
C3FFF8:	LDA #$FE  ; ' '
C3FFFA:	STA $2180  ; draw ' '; command changes from Fight to X Fight
C3FFFD:	DEY  ; decrement counter twice
C3FFFE:	DEY  ; draw 5 more tiles instead of 7

exit2:
C3FFFF:	RTS