
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C245F2  ; location in v1.0 or v1.1
;org $C245DA  ; location in SFC version
C245F2:	JSR $469C  ; v1.0 or v1.1
;C245F2:	JSR $4684  ; SFC only
;REMOVED1:	LDA #$4000
REPLACE1:
C245F5:	JSR $4653  ; v1.0 or v1.1
;C245F5:	JSR $4656  ; replaces this
;C245F5:	JSR $463B  ; SFC only
;C245F5:	JSR $463E  ; replaces this
	JSR near_fatal
C245FB:	LDA #$0040
C245FE:	BRA $464C  ; v1.0 or v1.1
;C245FE:	BRA $4634  ; SFC only

org $C25A8D  ; location in v1.0 or v1.1
;org $C25A75  ; location in SFC version
C25A8D: BCS secondary

org $C25A95  ; location in v1.0 or v1.1
;org $C25A7D  ; location in SFC version
C25A95: BCS return

org $C25AA1  ; location in v1.0 or v1.1
;org $C25A89  ; location in SFC version
C25A89: BCC return

org $C25AAB  ; location in v1.0 or v1.1
;org $C25A93  ; location in SFC version
C25AAB: BNE return
;	JMP nops  ; uncomment this instruction for "Premature Continuation"

org $C25AB6  ; location in v1.0 or v1.1
;org $C25A9E  ; location in SFC version
C25AB6: BNE return

org $C25AD6  ; location in v1.0 or v1.1
;org $C25ABE  ; location in SFC version
C25AD6: LDA $3AF0,X
REPLACE2:  ; buckle up...this is a huge replacement!
C25AD9:	LSR A
C25ADA:	BCS return
C25ADC:	LSR A
C25ADD:	BCS odd_check
C25ADF:	LDA #$08
C25AE1:	BRA set_bit

odd_check:
C25AE3:	LSR A
C25AE4:	BCS return
C25AE6:	LDA #$10

set_bit:
C25AE8:	ORA $3E4C,X
C25AEB:	STA $3E4C,X

return:  ; comment out this label if reversing
C25AEE:	RTS

;	TXY  ; this block gets replaced by ALL of that
;	AND #$07
;	ASL A
;	TAX
;	JMP (pointer_table_1,X)

secondary:
C25AEF:	SBC #$0A
C25AF1:	ASL A
C25AF2:	TAX
C25AF3:	JMP (pointer_table_2,X)

REPLACE3:
nops:  ; comment out this label if reversing
C25AF6:	NOP  ; these four NOPs replace two instructions and a jump table
C25AF7:	NOP
C25AF8:	NOP
C25AF9:	NOP
;restoreX:  ; uncomment this label if reversing
;C25AF6:	TYX
;return:  ; this label also
;C25AF7:	RTS

;pointer_table_1:  ; and this label
;DW regen_seizure,restoreX,poison,restoreX,regen_seizure,restoreX,restoreX,restoreX

;C25AF6:	STA $B8  ; replace the four NOPs with these two instructions
;C25AF8:	BRA remove_stop  ; if "Premature Continuation" is applied

pointer_table_2:
DW $5BB2,$5BFC  ; v1.0 or v1.1
;DW $5B9A,$5BE4  ; SFC only
DW return,return,return  ; there's one more pointer, but it's unchanged
DW $5BD0  ; v1.0 or v1.1
;DW $5BB8  ; SFC only

C25B06:	STA $B8
	LDA #$02
	PHX
REPLACE4:
check_timer:
C25B0B:	LDY $3F0C,X  ; we'll use A for the status and Y for the timer
;C25B0B:	LDA $3F0C,X  ; it doesn't matter where Y ends up
C25B0E:	BEQ after_reflect
C25B10:	DEC $3F0C,X
C25B13:	BNE after_reflect
;REMOVED2:	LDA #$02
C25B15:	TSB $B8

after_reflect:
REPLACE5:
C25B17:	ASL A  ; these five instructions replace six
C25B18:	INX
C25B19:	CMP #$08
C25B1B:	BCC check_timer
C25B1D:	PLX
;C25B17:	LDA $3F0D,X
;C25B18:	BEQ after_freeze
;C25B19:	DEC $3F0D,X
;C25B1A:	BNE after_freeze
;C25B1B:	LDA #$04
;C25B1C:	TSB $B8

after_freeze:
REPLACE6:
C25B1E:	LDY $3CF9,X
;C25B1E:	LDA $3CF9,X
C25B21:	BEQ after_sleep
C25B23:	DEC $3CF9,X
C25B26:	BNE after_sleep
;REMOVED3:	LDA #$08
C25B28:	TSB $B8

after_sleep:
C25B2A:	LDA $B8
C25B2C:	BEQ return

remove_stop:
C25B2E:	LDA #$29
C25B30:	JMP $4E91  ; v1.0 or v1.1
;C25B30:	JMP $4E79  ; SFC only
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

REPLACE7:  ; and the biggest replacement of all!
C25B3B:	NOP

near_fatal:
C25B39:	LDA $3C1C,Y  ; get max HP
C25B3C:	LSR A
C25B3D:	LSR A
C25B3E:	LSR A  ; divide by 8
C25B3F:	CMP $3BF4,Y  ; is maxHP / 8 >= curHP?
C25B42:	BCC exit  ; if so, queue Near Fatal status to be set
C25B44:	LDA #$0200
C25B47:	AND $331C,Y
C25B4A:	TSB $F8
C25B4C:	TRB $F4  ; also remove it from clearing queue

;poison:  ; uncomment these last two labels if reversing
;	TYX
;	LDA $3E4C,X
;	ORA #$10
;	STA $3E4C,X
;	RTS

;regen_seizure:
;	TYX
;	LDA $3E4C,X
;	ORA #$08
;	STA $3E4C,X

;poison:  ; for "Premature Continuation", uncomment this stuff instead
;	LDA #$10
;	BRA bra_in

;nops:
;	STA $B8
;	BRA remove_stop
;	NOP
;	RTS

;regen_seizure:
;	LDA #$08

;bra_in:
;	TYX
;	ORA $3E4C,X
;	STA $3E4C,X

exit:
C25B4E:	RTS