
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C207B0  ; location in v1.0 or v1.1
;org $C207A8  ; location in SFC version
REPLACE1:
C207B0:	PEA $2311  ; Rage, Freeze, Dance, Stop, Hide
;C207B0:	PEA $0311  ; minus Hide

org $C207B9  ; location in v1.0 or v1.1
;org $C207B1  ; location in SFC version
control_flags:
C207B9:	ASL $32B8,X
C207BC:	SEC
C207BD:	ROR $32B8,X
C207C0:	ASL $32B9,X
C207C3:	SEC
C207C4:	ROR $32B9,X
C207C7:	RTS

clear_zinger_charm_etc:
C207C8:	CPX $33F9
C207CB:	BNE after_zinger
C207CD:	PHX
C207CE:	LDX $33F8
C207D1:	LDA $3019,X
C207D4:	STA $B9
REMOVED1:
;	LDA #$04
;	STA $B8
C207D6:	LDX #$00
	LDY #$02
zinger_loop:
	TYA
	ASL A
	STA $B8
C207DE:	LDA #$24
C207E0:	JSR $4E91  ; v1.0 or v1.1
;C207E0:	JSR $4E79  ; SFC only
REMOVED2:
;	LDA #$02
;	STA $B8
C207E3:	LDX #$08
REPLACE2:
C207E5:	DEY  ; these two instructions...
C207E6:	BNE zinger_loop
;C207E5:	LDA #$24  ; ...replace these two
;C207E6:	JSR $4E91  ; v1.0 or v1.1
;C207E6:	JSR $4E79  ; SFC only
C207E8:	LDA #$FF
C207EA:	STA $33F8
C207ED:	STA $33F9
C207F0:	PLX
REPLACE3:
C207F1:	PHX  ; this one instruction...
;	LDA $336C,X  ; ...replace these three
;	BMI REPLACE4
;	TAY
C207F2:	JSR clear_love_token
REPLACE4:
C207F5:	TXA  ; these two instructions...
C207F6:	ADC #$28
;	LDA $336D,X  ; ...replace these four
;	BMI REMOVED3
;	PHX
;	TXY
C207F8:	TAX
C207F9:	JSR clear_love_token
C207FC:	PLX
REMOVED3:
;	LDA $3394,X
;	BMI after_charmee
;	TAY
;	JSR REMOVED4
;after_charmee:
;	LDA $3395,X
;	BMI after_charmer
;	PHX
;	TXY
;	TAX
;	JSR REMOVED4
;	PLX
;after_charmer:
C207FD:	CPX $3404  ; compare to Quick's target byte
C20800:	BNE exit  ; exit if actor is not Quick
C20802:	LDA #$FF
C20804:	STA $3404  ; empty to Quick's target byte
C20807:	STA $3402  ; 0 to number of turns

exit:
C2080A:	RTS

clear_love_token:
	LDA $336C,X  ; get slave
	BMI after_slave  ; branch if it doesn't exist
	TAY  ; put slave in Y
	JSR clear_link

after_slave:
	LDA $336D,X  ; get master
	BMI after_master  ; branch if it doesn't exist
	TXY  ; put slave in Y
	TAX  ; put master in X
	JSR clear_link
	TYX  ; restore X

after_master:
	RTS

palidor_control:
	LDA $3204,X
	AND #$BF
	STA $3204,X
	RTS
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

clear_link:
C20836:	LDA #$FF
C20838:	STA $336C,X  ; master has no slave
C2083B:	STA $336D,Y  ; slave has no master
C2083E:	RTS

REMOVED4:
;	LDA #$FF
;	STA $3394,X
;	STA $3395,Y
;	RTS

org $C20B72  ; location in v1.0 or v1.1
;org $C20B6A  ; location in SFC version
REPLACE5:
C20B72:	ASL $3205,X  ; replacing one instruction at a time now
;C20B72:	LDA $3205,X
REMOVED5:
;	AND #$7F  ; clear top bit; both solutions work, mine is smaller
REPLACE6:
C20B75:	LSR $3205,X
;C20B75:	STA $3205,X
C20B78:	STZ $3AB5,X  ; zero top byte of wait timer
C20B7B:	LDA #$E0
C20B7D:	STA $322C,X  ; save delay between inputting command and performing it
REPLACE7:
C20B80:	JMP palidor_control
;C20B80:	RTS

org $C2144F  ; location in v1.0 or v1.1
;org $C2144A  ; location in SFC version
C2144F:	PHP
REMOVED6:
;	REP #$20
C21450:	LDX #$12  ; switch this instruction with REP #$20 when reversing
entity_loop:
	REP #$20  ; 16-bit A
C21454:	LDA $3018,X
C21457:	TRB $2F4C  ; set to remove entity from battlefield
C2145A:	BEQ next  ; skip if already done so
C2145C:	SEP #$20  ; 8-bit A
C2145E:	XBA
C2145F:	TRB $2F2F  ; remove from enemy list
C21462:	LDA #$FE
C21464:	JSR $0792  ; v1.0 or v1.1
;C21464:	JSR $078A  ; SFC only
REPLACE7:
C21467:	PHY  ; these three instructions...
C21468:	TXY
C21469:	JSR $1F00  ; v1.0 or v1.1
;C21469:	JSR $1EFB  ; SFC only
;C21467:	LDA $3EF9,X  ; ...replace these three
;C21468:	ORA #$20
;C21469:	STA $3EF9,X
C2146C:	JSR clear_zinger_charm_etc
REPLACE8:
C2146F:	JSR control_flags  ; these two instructions...
C21472:	PLY
;C2146F:	REP #$20  ; ...replace this one

next:
C21473:	DEX
C21474:	DEX
C21475:	BPL entity_loop  ; loop over all entities
C21477:	PLP
C21478:	RTS