
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C2415B  ; location in v1.0 and v1.1
;org $C24143  ; location in SFC version only
	LDA $B5
	PHA
	LDA $3C58,Y
	PHA
C24162:	LDA #$20
C24164:	TSB $11A4
C24167:	LDA #$0F
C24169:	STA $B7
C2416B:	TDC
	LDY $11A8
	DEY
	PHY

new_random:
C24171:	JSR $4B5A  ; v1.0 or v1.1
;C24171:	JSR $4B42  ; SFC only
;REMOVED1:
;	PHA
;	AND #$0F

roll_die:
C24174:	LDX #$06
C24176:	JSR $4792  ; v1.0 or v1.1
;C24176:	JSR $477A  ; SFC only
	TXA
	TYX
	STA $B5,X
;REMOVED2:
;	STX $B7
;	INX
;	STX $EE
;	PLA
;	LDX #$60
;	JSR $4792  ; v1.0 or v1.1
;	JSR $477A  ; SFC only
;	TXA
;	AND #$F0
;	ORA $B7
;	STA $B7
;	LSR A
;	LSR A
;	LSR A
;	LSR A
;	INC A
;	XBA
;	LDA $EE
;	JSR $4781  ; v1.0 or v1.1
;	JSR $4769  ; SFC only
;	STA $EE
;	LDA $11A8
;	CMP #$03
;	BCC $41AB
;	TDC
C2417D:	LDA $021E
	DEY
	BEQ roll_die
	BPL new_random
	PLX
	PHX  ; optional
	LDA #$01
;REMOVED3:
;	LDX #$06
;	JSR $4792  ; v1.0 or v1.1
;	JSR $477A  ; SFC only
;	TXA
;	STA $B6
;	INC A

multiply_dice:
C24189:	XBA
	LDA $B5,X
	INC A
;REMOVED4:	LDA $EE
C2418D:	JSR $4781  ; v1.0 or v1.1
;C2418D:	JSR $4769  ; SFC only
	DEX
	BPL multiply_dice
;REMOVED5:
;	STA $EE
;	LDX #$00
;	LDA $B6
;	ASL A
;	ASL A
;	ASL A
;	ASL A
;	ORA $B6
;	CMP $B7
;	BNE $41BB
;	LDX $B6
;	LDA $EE
C24193:	XBA
	LDA $02,S  ; comment out only if you also commented out the above PHX
;	PLA  ; if you did, also uncomment this instruction
	LSR A
C24197:	LDA $11AF
	BCS multiply_level
C2419C:	ASL A

multiply_level:
C2419D:	JSR $4781  ; v1.0 or v1.1
;C2419D:	JSR $4169  ; SFC only
C241A0:	REP #$20
;REMOVED6:
;	STA $EE
;bonus:  ; uncomment if removing this fix
;	CLC
C241A2:	STA $11B0
	SEP #$20
	PLX  ; comment out only if you also commented out the above PHX
	PLA  ; if you did, also comment out this instruction...
;	LDX #$06  ; ...and uncomment this instruction
	LDA $B5

compare_dice:
	CMP $B5,X
	BNE exit
	DEX
	BNE compare_dice
	TAX
	TDC
	REP #$21
;REMOVED7: LDA $EE

bonus:  ; comment out if removing this fix
C241B6:	ADC $11B0
	BCS overflow
;REMOVED8:
;	BCC iterate
;	TDC
;	DEC A

iterate:
C241BB:	DEX
C241BC:	BPL bonus
	BRA finalize
	TDC
	DEC A

finalize:
	STA $11B0

exit:
	REP #$20
	LDA $B6
	XBA
	STA $B6
C241CC:	SEP #$20
	TDC
C241CF:	LDA $B5
	ASL A
	ASL A
	ASL A
	ASL A
	TSB $B7
	PLA
;REMOVED9:	CMP #$00

;	BEQ dice_replace  ; uncomment if using the version compatible
;	CMP #$06  ; with Assassin's "Recapture the Glory" patch
C241D8:	BNE save_command

dice_replace:
C241DA:	LDA #$26

save_command:
C241DC:	STA $B5
C241DE:	RTS

padbyte $EA : pad $C241E5  ; v1.0 or v1.1
;padbyte $EA : pad $C241CD  ; SFC only