
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C104E4
REPLACE1:
C104E4:	LDA $C2D2B4,X  ; v1.0 or v1.1
;C104E4:	LDA $C2D256,X  ; SFC only
C104E8:	LSR A
C104E9:	ADC $7BBE  ; v1.0 or v1.1
;C104E9:	ADC $7B8E  ; SFC only

;replaces the following
;C104E4:	LDA $7BBE  ; v1.0 or v1.1
;C104E4:	LDA $7B8E  ; SFC only
;C104E7:	CLC
;C104E8:	ADC $C2D294,X  ; v1.0 or v1.1
;C104E8:	ADC $C2D236,X  ; SFC only

org $C109DE  ; location in v1.0 or v1.1
;org $C109C1  ; location in SFC version
C109DE:	ASL A

sprite_loop:
C109DF:	TAX
C109E0:	REP #$20  ; 16-bit A
C109E2:	LDA $C2D2C4,X  ; v1.0 or v1.1
;C109E2:	LDA $C2D266,X  ; SFC only
C109E6:	STA $4372
C109E9:	LDA $C2D2D4,X  ; v1.0 or v1.1
;C109E9:	LDA $C2D276,X  ; SFC only
C109ED:	STA $2116
C109F0:	LDY #$0080
C109F3:	STY $4375

REPLACE2:
C109F6:	STY $420B
C109F9:	JSR backup_sprite  ; redraw the player sprite in secondary location
C109FC:	TXA
C109FD:	CLC
C109FE:	ADC #$0008
C10A01:	CMP #$0010
C10A04:	BCC sprite_loop
C10A06:	LDA $7E64BA  ; v1.0 or v1.1
;C10A06:	LDA $7E648A  ; SFC only
C10A0A:	LSR A
C10A0B:	BCC sprite_exit
C10A0D:	JSR clear_legs

sprite_exit:
C10A10:	TDC
C10A11:	SEP #$20  ; 8-bit A
C10A13:	RTS
C10A14:	NOP
C10A15:	NOP

;C109F6:	LDA #$0080  ; replaces all of this
;C109F9:	STA $420B
;C109FC:	LDA $C2D2CC,X  ; v1.0 or v1.1
;C109FC:	LDA $C2D26E,X  ; SFC only
;C10A00:	STA $4372
;C10A03:	LDA $C2D2DC,X  ; v1.0 or v1.1
;C10A03:	LDA $C2D27E,X  ; SFC only
;C10A07:	STA $2116
;C10A0A:	STY $4375
;C10A0D:	LDA #$0080
;C10A10:	SEP #$20  ; 8-bit A
;C10A12:	STA $420B
;C10A15:	RTS

org $C129B9  ; location in v1.0
;org $C129B6  ; location in v1.1
;org $C12991  ; location in SFC version
REPLACE3:
C129B9:	JSR get_magitek  ; replaces the LDA
;C129B9:	LDA $64BA  ; v1.0 or v1.1
;C129B9:	LDA $648A  ; SFC only

; WARNING! This padbyte should NOT be included unless "Side Saddle" has
; been applied. If it has, uncomment it; otherwise, leave it!
;org $C1301E  ; location in v1.0
;org $C1301B  ; location in v1.1
;org $C12FF6  ; location in SFC version
;padbyte $EA : pad $C13050  ; v1.0 only
;padbyte $EA : pad $C1304D  ; v1.1 only
;padbyte $EA : pad $C13028  ; SFC only

org $C134A9  ; location in v1.0
;org $C134A6  ; location in v1.1
;org $C13481  ; location in SFC version
REPLACE4:
C134A9:	JSR get_magitek  ; replaces the LDA
;C134A9:	LDA $64BA  ; v1.0 or v1.1
;C134A9:	LDA $648A  ; SFC only

org $C1356C  ; location in v1.0
;org $C13569  ; location in v1.1
;org $C13544  ; location in SFC version
REPLACE5:
C1356C:	JSR get_magitek  ; replaces the LDA
;C1356C:	LDA $64BA  ; v1.0 or v1.1
;C1356C:	LDA $648A  ; SFC only

org $C136FC  ; location in v1.0
;org $C136F9  ; location in v1.1
;org $C136D4  ; location in SFC version
C136FC:	LDA $202A,X
C136FF:	BEQ exit
C13701:	TXA
C13702:	ASL A
C13703:	TAX
C13704:	PHB
;REMOVED1:
;	LDA #$7F
;	PHA
;	PLB
C13705:	REP #$20
REPLACE6:
C13707:	LDY $E9D2,X  ; v1.0 or v1.1
;C13707:	LDA $7EE9D2,X  ; replaces this
;C13707:	LDY $E9A2,X  ; SFC only
;C13707:	LDA $7EE9A2,X  ; replaces this
;REMOVED2:	TAY
C1370A:	LDA $C2E41A,X  ; v1.0 or v1.1
;C1370A:	LDA $C2E3DC,X  ; SFC only
REPLACE7:
C1370E:	TYX
C1370F:	TAY
C13710:	LDA #$003F
C13713:	MVN $7F,$7F

;C1370E:	TAX  ; replaces all of this
;			LDA #$0008
;			STA $3A
manual_loop:
;			LDA $0000,Y
;			STA $0000,X
;			LDA $0010,Y
;			STA $0010,X
;			LDA $0020,Y
;			STA $0020,X
;			LDA $0030,Y
;			STA $0030,X
;			INY
;			INY
;			INX
;			INX
;			DEC $3A
;			BNE manual_loop

C13716:	TDC
C13717:	SEP #$20
C13719:	PLB

exit:
C1371A:	RTS

backup_sprite:  ; these two functions are newly added
C1371B:	LDA $7E64BA  ; v1.0 or v1.1
;C1371B:	LDA $7E648A  ; SFC only
C1371F:	LSR A
C13720:	LSR A
C13721:	BCC exit_backup
C13723:	LDA backup_table,X
C13727:	STA $2116
C1372A:	LDA $C2D2C4,X  ; v1.0 or v1.1
;C1372A:	LDA $C2D2C4,X  ; SFC only
C1372E:	STA $4372
C13731:	STY $4375
C13734:	STY $420B
C13737:	RTS

get_magitek:
C13738:	LDA $64BA  ; v1.0 or v1.1
;C13738:	LDA $648A  ; SFC only
C1373B:	AND #$01
C1373D:	RTS
C1373E:	NOP

org $C1377F  ; location in v1.0
;org $C1377C  ; location in v1.1
;org $C13757  ; location in SFC version
;REMOVED3:
;	LDA $7E64BA  ; v1.0 or v1.1
;	LDA $7E648A  ; SFC only
;	AND #$00FF
;	BNE exit_legs
C1377F:	LDA $38
C13781:	CLC
C13782:	ADC #$0240
C13785:	TAY
C13786:	LDA #$003F
C13789:	MVN $7F,$7F

exit_legs:
C1378C:	TDC
C1378D:	SEP #$20
C1378F:	PLB
C13790:	RTS

load_extra:  ; new function
	STY $7B37  ; v1.0 or v1.1
;	STY $7B07  ; SFC only
	RTS
	NOP
	NOP
	NOP
	NOP
	NOP

org $C13CE0  ; location in v1.0
;org $C13CDD  ; location in v1.1
;org $C13C8E  ; location in SFC version
REPLACE8:
C13CE0:	JSR get_magitek  ; replaces the LDA
;C13CE0:	LDA $64BA  ; v1.0 or v1.1
;C13CE0:	LDA $648A  ; SFC only

org $C13D87  ; location in v1.0
;org $C13D84  ; location in v1.1
;org $C13D5F  ; location in SFC version
C13D87:	CMP #$FFFF  ; not required unless "Side Saddle" has been applied

org $C193C0  ; location in v1.0
;org $C193BD  ; location in v1.1
;org $C19373  ; location in SFC version
REPLACE9:
C193C0:	JSR get_magitek  ; replaces the LDA
;C193C0:	LDA $64BA  ; v1.0 or v1.1
;C193C0:	LDA $648A  ; SFC only

org $C199EF  ; location in v1.0
;org $C199EC  ; location in v1.1
;org $C1999D  ; location in SFC version
REPLACE10:
C199EF:	JSR get_magitek  ; replaces the LDA
;C199EF:	LDA $64BA  ; v1.0 or v1.1
;C199EF:	LDA $648A  ; SFC only

org $C19A0C  ; location in v1.0
;org $C19A09  ; location in v1.1
;org $C199BA  ; location in SFC version
REPLACE11:
C19A0C:	JSR get_magitek  ; replaces the LDA
;C19A0C:	LDA $64BA  ; v1.0 or v1.1
;C19A0C:	LDA $648A  ; SFC only

org $C19CE1  ; location in v1.0
;org $C19CDE  ; location in v1.1
;org $C19C8F  ; location in SFC version
	TDC
	TAY

next_graphics:
	LDX $6273,Y  ; v1.0 or v1.1
;	LDX $6243,Y  ; SFC only

last_iteration:
	PHY
	INX
	BEQ skip_graphics
	DEX
	JSR $A18B  ; v1.0 only
;	JSR $A188  ; v1.1 only
;	JSR $A139  ; SFC only
	LDY $7AEE  ; v1.0 or v1.1
;	LDY $7ABE  ; SFC only
	LDA $60AE  ; v1.0 or v1.1
;	LDA $607E  ; SFC only
	INC A
	PLX
	PHX
	JSR (graphics_jump,X)

skip_graphics:
	PLY
	BNE continue
	PHY
	JSR $9917  ; v1.0 only
;	JSR $9914  ; v1.1 only
;	JSR $98C5  ; SFC only
	PLY

continue:
	INY
	INY
	LDX $627E  ; v1.0 or v1.1
;	LDX $624E  ; SFC only
	CPY #$0006
	BCC next_graphics
	BEQ last_iteration
	JSR $A0AC  ; v1.0 only
;	JSR $A0A9  ; v1.1 only
;	JSR $A05A  ; SFC only
	LDA $6279  ; v1.0 or v1.1
;	LDA $6249  ; SFC only
	JSR $9BD7  ; v1.0 only
;	JSR $9BD4  ; v1.1 only
;	JSR $9B85  ; SFC only
	LDA $627A  ; v1.0 or v1.1
;	LDA $624A  ; SFC only
	STA $6167  ; v1.0 or v1.1
;	STA $6137  ; SFC only
	LDA $627B  ; v1.0 or v1.1
;	LDA $624B  ; SFC only
	JSR $9C6B  ; v1.0 only
;	JSR $9C68  ; v1.1 only
;	JSR $9C19  ; SFC only
	JMP $A771  ; v1.0 only
;	JMP $A76E  ; v1.1 only
;	JMP $A71F  ; SFC only

graphics_jump:
DW load1,load2,load3,load_extra

load1:
;REMOVED4:
;	LDX $6273  ; v1.0 or v1.1
;	LDX $6243  ; SFC only
;	CPX #$FFFF
;	BEQ load2
;	JSR $A18B  ; v1.0 only
;	JSR $A188  ; v1.1 only
;	JSR $A139  ; SFC only
;	LDX $7AEE  ; v1.0 or v1.1
;	LDX $7ABE  ; SFC only
REPLACE12:
C19D2E:	STY $7B35  ; v1.0 or v1.1
;C19D2E:	STX $7B35  ; replaces this
;C19D2E:	STY $7B05  ; SFC only
;C19D2E:	STX $7B05  ; replaces this
C19D31:	LDX $7AEA  ; v1.0 or v1.1
;C19D31:	LDX $7ABA  ; SFC only
REPLACE13:
C19D34:	DEC A  ; replaces LDA
;C19D34:	LDA $60AE  ; v1.0 or v1.1
;C19D34:	LDA $607E  ; SFC only
C19D35:	BNE skip1
C19D37:	JSR $A1B1  ; v1.0 only
;C19D37:	JSR $A1AE  ; v1.1 only
;C19D37:	JSR $A15F  ; SFC only

skip1:
REPLACE14:
C19D3A:	JMP $A0B5  ; v1.0 only
;C19D3A:	JSR $A0B5  ; replaces this
;C19D3A:	JMP $A0B2  ; v1.1 only
;C19D3A:	JSR $A0B2  ; replaces this
;C19D3A:	JMP $A063  ; SFC only
;C19D3A:	JSR $A063  ; replaces this

load2:
;REMOVED5:
;	JSR $9917  ; v1.0 only
;	JSR $9914  ; v1.1 only
;	JSR $98C5  ; SFC only
;	LDX $6275  ; v1.0 or v1.1
;	LDX $6245  ; SFC only
;	CPX #$FFFF
;	BEQ load3
;	JSR $A18B  ; v1.0 only
;	JSR $A188  ; v1.1 only
;	JSR $A139  ; SFC only
;	LDX $7AEE  ; v1.0 or v1.1
;	LDX $7ABE  ; SFC only
REPLACE15:
C19D3D:	STY $7B31  ; v1.0 or v1.1
;C19D3D:	STX $7B31  ; replaces this
;C19D3D:	STY $7B01  ; SFC only
;C19D3D:	STX $7B01  ; replaces this
C19D40:	LDX $7AEA  ; v1.0 or v1.1
;C19D40:	LDX $7ABA  ; SFC only
REPLACE16:
C19D43:	DEC A  ; replaces LDA
;C19D43:	LDA $60AE  ; v1.0 or v1.1
;C19D43:	LDA $607E  ; SFC only
C19D44:	BNE skip2
C19D46:	JSR $A1E0  ; v1.0 only
;C19D46:	JSR $A1DD  ; v1.1 only
;C19D46:	JSR $A18E  ; SFC only

skip2:
C19D49:	LDX $6275  ; v1.0 or v1.1
;C19D49:	LDX $6245  ; SFC only
C19D4C:	CPX #$0225
C19D4F:	BEQ match
REPLACE17:
C19D51:	CPX #$003C
;C19D51:	CPX #$003B  ; replaces this
C19D54:	BEQ match
C19D56:	CPX #$0216
C19D59:	BEQ match
REPLACE18:
C19D5B:	CPX #$003B
;C19D5B:	CPX #$003C  ; replaces this
C19D5E:	BNE no_match
	LDA #$02
	TSB $64BA  ; v1.0 or v1.1
;	TSB $648A  ; SFC only

match:
C19D65:	JSR $9F12  ; v1.0 only
;C19D65:	JSR $9F0F  ; v1.1 only
;C19D65:	JSR $9EC0  ; SFC only
C19D68:	LDA #$2E
C19D6A:	BRA setup

no_match:
C19D6C:	JSR $9F1C  ; v1.0 only
;C19D6C:	JSR $9F19  ; v1.1 only
;C19D6C:	JSR $9ECA  ; SFC only
C19D6F:	LDA #$2C

setup:
C19D71:	JSR $9F61  ; v1.0 only
;C19D71:	JSR $9F5E  ; v1.1 only
;C19D71:	JSR $9F0F  ; SFC only
REPLACE19:
C19D74:	JMP end2
;C19D74:	JSR end2  ; replaces this

load3:
;REMOVED6:
;	LDX $6277  ; v1.0 or v1.1
;	LDX $6247  ; SFC only
;	CPX #$FFFF
;	BEQ clear_backup
;	JSR $A18B  ; v1.0 only
;	JSR $A188  ; v1.1 only
;	JSR $A139  ; SFC only
;	LDX $7AEE  ; v1.0 or v1.1
;	LDX $7ABE  ; SFC only
REPLACE20:
C19D77:	STY $7B33  ; v1.0 or v1.1
;C19D77:	STX $7B33  ; replaces this
;C19D77:	STY $7B03  ; SFC only
;C19D77:	STX $7B03  ; replaces this
C19D7A:	LDX $7AEA  ; v1.0 or v1.1
;C19D7A:	LDX $7ABA  ; SFC only
REPLACE21:
C19D7D:	DEC A  ; replaces LDA
;C19D7D:	LDA $60AE  ; v1.0 or v1.1
;C19D7D:	LDA $607E  ; SFC only
C19D7E:	BNE skip3
C19D80:	JSR $A1CF  ; v1.0 only
;C19D80:	JSR $A1CC  ; v1.1 only
;C19D80:	JSR $A17D  ; SFC only

skip3:
C19D83:	JSR $9F4A  ; v1.0 only
;C19D83:	JSR $9F47  ; v1.1 only
;C19D83:	JSR $9EF8  ; SFC only
REPLACE22:
C19D86:	JMP end3
;C19D86:	JSR end3  ; replaces this

clear_backup_bg1:
REPLACE23:
C19D89:	STY $64B4  ; v1.0 or v1.1
;C19D89:	STY $6484  ; SFC only

clear_backup:
C19D8C:	LDA #$02
C19D8E:	TRB $64BA  ; v1.0 or v1.1
;C19D8E:	TRB $648A
C19D91:	RTS
C19D92:	NOP
C19D93:	NOP
C19D94:	NOP

;	LDX $627E  ; v1.0 or v1.1 ; replaces all of this
;	LDX $624E  ; SFC only
;	CPX #$FFFF
;	BEQ skip_extra
;	JSR $A18B  ; v1.0 only
;	JSR $A188  ; v1.1 only
;	JSR $A139  ; SFC only
skip_extra:
;	LDX $7AEE  ; v1.0 or v1.1
;	LDX $7ABE  ; SFC only
;	STX $7B37  ; v1.0 or v1.1
;	STX $7B07  ; SFC only
;	JSR $A0AC  ; v1.0 only
;	JSR $A0A9  ; v1.1 only
;	JSR $A05A  ; SFC only
;	LDA $6279  ; v1.0 or v1.1
;	LDA $6249  ; SFC only
;	JSR $9BD7  ; v1.0 only
;	JSR $9BD4  ; v1.1 only
;	JSR $9B85  ; SFC only
;	TDC
;	LDA $627A  ; v1.0 or v1.1
;	LDA $624A  ; SFC only
;	STA $6167  ; v1.0 or v1.1
;	STA $6137  ; SFC only
;	LDA $627B  ; v1.0 or v1.1
;	LDA $624B  ; SFC only
;	JSR $9C6B  ; v1.0 only
;	JSR $9C68  ; v1.1 only
;	JSR $9C19  ; SFC only
;	JSR $A771  ; v1.0 only
;	JSR $A76E  ; v1.1 only
;	JSR $A71F  ; SFC only
;	RTS

org $C19E3A  ; location in v1.0
;org $C19E37  ; location in v1.1
;org $C19DE8  ; location in SFC version
end2:
;REMOVED7:
;	LDA $28
;	BEQ clear_legs
C19E3A:	LDA $7B31  ; v1.0 or v1.1
;C19E3A:	LDA $7B01  ; SFC only
C19E3D:	REP #$20  ; 16-bit A
C19E3F:	ASL A
C19E40:	ASL A
C19E41:	ASL A
C19E42:	STA $7B16  ; v1.0 or v1.1
;C19E42:	STA $7AE6  ; SFC only
	LDA $28
	AND #$00FF
	BEQ continue2
C19E4C:	LDA #$0100
C19E4F:	SEC
C19E50:	SBC $7B16  ; v1.0 or v1.1
;C19E50:	SBC $7AE6  ; SFC only
C19E53:	STA $7B16  ; v1.0 or v1.1
;C19E53:	STA $7AE6  ; SFC only

continue2:
C19E56:	LDA $7B32  ; v1.0 or v1.1
;C19E56:	LDA $7B02  ; SFC only
C19E59:	AND #$00FF
C19E5C:	ASL A
C19E5D:	ASL A
C19E5E:	ASL A
C19E5F:	STA $7B18  ; v1.0 or v1.1
;C19E5F:	STA $7AE8  ; SFC only
C19E62:	TDC
C19E63:	SEP #$20  ; 8-bit A
REPLACE24:
C19E65:	RTS
;C19E65:	JMP clear_tile

clear_legs:
REPLACE25:
C19E66:	LDA $C2D2D4,X  ; v1.0 or v1.1
;C19E66:	LDA $C2D276,X  ; SFC only
C19E6A:	CLC
C19E6B:	ADC #$0020
C19E6E:	STA $2116
C19E71:	LDY #$0040

;C19E65:	LDA $7B31  ; v1.0 or v1.1 ; replaces all of this
;C19E65:	LDA $7B01  ; SFC only
;C19E68:	REP #$20  ; 16-bit A
;C19E6A:	ASL A
;C19E6B:	ASL A
;C19E6C:	ASL A
;C19E6D:	STA $7B16  ; v1.0 or v1.1
;C19E6D:	STA $7AE6  ; SFC only
;C19E70:	LDA $7B32  ; v1.0 or v1.1
;C19E70:	LDA $7B02  ; SFC only
;C19E73:	AND #$00FF
;C19E76:	ASL A
;C19E77:	ASL A
;C19E78:	ASL A
;C19E79:	STA $7B18  ; v1.0 or v1.1
;C19E79:	STA $7AE8  ; SFC only
;C19E7C:	TDC
;C19E7D:	SEP #$20  ; 8-bit A

clear_tile:
	STZ $2118
	DEY
	DEY
	BNE clear_tile
C19E7B:	RTS

clear_backup_sprite:
	STZ $64DE,X  ; v1.0 or v1.1
;	STZ $64AE,X  ; SFC only
	JMP clear_backup

padbyte $EA : pad $C19E9A  ; v1.0 only
;padbyte $EA : pad $C19E97  ; v1.1 only
;padbyte $EA : pad $C19E48  ; SFC only

end3:
;REMOVED8:
;	LDA $28
;	BEQ continue3
C19E9A:	LDA $7B33  ; v1.0 or v1.1
;C19E9A:	LDA $7B01  ; SFC only
C19E9D:	REP #$20  ; 16-bit A
C19E9F:	ASL A
C19EA0:	ASL A
C19EA1:	ASL A
C19EA2:	STA $7B22  ; v1.0 or v1.1
;C19EA2:	STA $7AF2  ; SFC only
	LDA $28
	AND #$00FF
	BEQ continue3
C19EAC:	LDA #$0100
C19EAF:	SEC
C19EB0:	SBC $7B22  ; v1.0 or v1.1
;C19EB0:	SBC $7AF2  ; SFC only
C19EB3:	STA $7B22  ; v1.0 or v1.1
;C19EB3:	STA $7AF2  ; SFC only
;REMOVED9:
;	LDA $7B34  ; v1.0 or v1.1
;	LDA $7B04  ; SFC only
;	AND #$00FF
;	ASL A
;	ASL A
;	ASL A
;	STA $7B24  ; v1.0 or v1.1
;	STA $7AF4  ; SFC only
;	TDC
;	SEP #$20  ; 8-bit A
;	JMP to_rts

continue3:
;REMOVED10:
;	LDA $7B33  ; v1.0 or v1.1
;	LDA $7B01  ; SFC only
;	REP #$20  ; 16-bit A
;	ASL A
;	ASL A
;	ASL A
;	STA $7B22  ; v1.0 or v1.1
;	STA $7AF2  ; SFC only
C19EB6:	LDA $7B34  ; v1.0 or v1.1
;C19EB6:	LDA $7B04  ; SFC only
C19EB9:	AND #$00FF
C19EBC:	ASL A
C19EBD:	ASL A
C19EBE:	ASL A
C19EBF:	STA $7B24  ; v1.0 or v1.1
;C19EBF:	STA $7AF4  ; SFC only
C19EC2:	TDC
C19EC3:	SEP #$20  ; 8-bit A

to_rts:
C19EC5:	RTS

org $C1C705  ; location in v1.0
;org $C1C702  ; location in v1.1
;org $C1C6B3  ; location in SFC
REPLACE26:
C1C705:	JSR clear_backup_sprite  ; JSR replaces STZ
;C1C705:	STZ $64DE,X  ; v1.0 or v1.1
;C1C705:	STZ $64AE,X  ; SFC only

org $C1C7D5  ; location in v1.0
;org $C1C7D2  ; location in v1.1
;org $C1C783  ; location in SFC
;REMOVED11:
;	STY $64B4  ; v1.0 or v1.1
;	STY $6484  ; SFC only
C1C7D5:	CLC
	JMP clear_backup_bg1

org $C1DB34  ; location in v1.0
;org $C1DB31  ; location in v1.1
;org $C1DAE2  ; location in SFC version
REPLACE27:
C1DB34:	JSR get_magitek  ; replaces the LDA
;C1DB34:	LDA $64BA  ; v1.0 or v1.1
;C1DB34:	LDA $648A  ; SFC only

org $C1E272  ; location in v1.0
;org $C1E285  ; location in v1.1
;org $C1E220  ; location in SFC version
REPLACE28:
C1E272:	AND #$01
;C1E272:	AND #$FF  ; replaces this completely unnecessary instruction

org $C1F738  ; location in v1.0
;org $C1F74B  ; location in v1.1
;org $C1F6E6  ; location in SFC version
REPLACE29:
C1F738:	JSR get_magitek  ; replaces the LDA
;C1F738:	LDA $64BA  ; v1.0 or v1.1
;C1F738:	LDA $648A  ; SFC only

org $C1F769  ; location in v1.0
;org $C1F77C  ; location in v1.1
;org $C1F717  ; location in SFC version
REPLACE30:
C1F738:	JSR get_magitek  ; replaces the LDA
;C1F738:	LDA $64BA  ; v1.0 or v1.1
;C1F738:	LDA $648A  ; SFC only

org $C1FED1  ; location in v1.0
;org $C1FEE4  ; location in v1.1
;org $C1FE7F  ; location in SFC version
REPLACE31:
C1FED1:	JSR get_magitek  ; replaces the LDA
;C1FED1:	LDA $64BA  ; v1.0 or v1.1
;C1FED1:	LDA $648A  ; SFC only

org $C2D294  ; location in v1.0 or v1.1
;org $C2D236  ; location in SFC version
backup_table:
REPLACE32:
DW $2640,$2680,$2840,$2880,$2740,$2780,$2940,$2980
;DW $0000,$0020,$0040,$0060,$0080,$00A0,$00C0,$00E0

org $D1066B
REPLACE33:
DW $1A00,$1B01,$1C00,$1D01,$2200,$2301,$2400,$2501
;DW $0000,$0101,$0200,$0301,$0400,$0501,$0600,$0701