
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C25B04  ; location in v1.0 or v1.1
;org $C25AEC  ; location in SFC version
DW process_runners

org $C25BB2  ; location in v1.0 or v1.1
;org $C25B9A  ; location in SFC version
;REMOVED1:
;	LDA $2F43
;	BMI $5B4E  ; v1.0 or v1.1
;	BMI $5B36  ; SFC only
	PHP
C25BB3:	REP #$20  ; 16-bit A
C25BB5:	LDA $2F42  ; get Roulette target
	BMI plp_exit  ; exit if none
C25BBA:	JSR $51F9  ; v1.0 or v1.1
;C25BBA:	JSR $51E1  ; SFC only
C25BBD:	TDC
C25BBE:	DEC A
C25BBF:	STA $2F42  ; clear Roulette targets
REPLACE1:  ; one instruction replaces one
C25BC2:	PLP  ; 8-bit A
;C25BC2:	SEP #$20
C25BC3:	TYX
	BRA queue_doom
	NOP
	LSR $3EE5,X
	ASL $3EE5,X

queue_doom:
C25BCD:	LDA #$0D
C25BCF:	STA $B8  ; set up Doom spell
REPLACE2:  ; three replace two
C25BD1:	TDC
C25BD2:	BRA queue_animation
C25BD4:	NOP
;C25BD2:	LDA #$26
;C25BD3:	JMP $4E91  ; v1.0 or v1.1
;C25BD3:	JMP $4E79  ; SFC only

process_runners:
;REMOVED2:
;	LDA $2F45
;	BEQ exit
C25BD5:	LDA $B1
C25BD7:	BIT #$02
C25BD9:	BNE check_run  ; branch if "Can't Run" bit is set
C25BDB:	LDA $3A91
C25BDE:	AND #$70
C25BE0:	BNE exit  ; 1-in-8 chance of running
;REMOVED3:
;	LDA $2F45
;	BEQ exit
C25BE2:	LDA $3A38
C25BE5:	BEQ exit
C25BE7:	LDA $3A97
C25BEA:	BNE exit
	LDA $2F45
	BEQ exit
C25BF1:	LDA #$04
C25BF3:	TSB $B0
C25BF5:	BNE exit

queue_animation:
REPLACE3:  ; one replaces one
C25BF7:	ADC #$26
;C25BF7:	LDA #$2A
C25BF9:	JMP $4E91  ; v1.0 or v1.1
;C25BF9:	JMP $4E79  ; SFC only

org $C25C19  ; location in v1.0 or v1.1
;org $C25C01  ; location in SFC version
plp_exit:	PLP
exit:		RTS