
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C1A79B  ; location in v1.0
;org $C1A798  ; location in v1.1
;org $C1A749  ; location in SFC version
C1A79B:	JSR $94F4  ; v1.0 only
;C1A79B:	JSR $94F1  ; v1.1 only
;C1A79B:	JSR $94A7  ; SFC only
C1A79E:	INC $62D1  ; v1.0 or v1.1
;C1A79E:	INC $61A1  ; SFC only
C1A7A1:	TDC
C1A7A2:	TAY
C1A7A3:	STY $613D  ; v1.0 or v1.1
;C1A7A3:	STY $610D  ; SFC only
	STY $12

reflect_loop:
C1A7A8:	LDA ($78),Y  ; get the new target of the Reflected spell
C1A7AA:	BMI iterate  ; branch if target is invalid
	REP #$20  ; 16-bit A
	ASL A
	PHA  ; push post-Reflect target
C1A7B0:	TYA
C1A7B1:	ASL A
C1A7B2:	TAX
C1A7B3:	LDA $C1A75D,X  ; v1.0 only
;C1A7B3:	LDA $C1A75A,X  ; v1.1 only
;C1A7B3:	LDA $C1A70B,X  ; SFC only
	TSB $12
	PLX  ; pull post-Reflect target
	ORA $C1A75D,X  ; v1.0 only
;	ORA $C1A75A,X  ; v1.1 only
;	ORA $C1A70B,X  ; SFC only
REPLACE1:
C1A7BE:	TSB $613D  ; v1.0 or v1.1
;C1A7BE:	ORA $613D  ; replaces this
;C1A7BE:	TSB $610D  ; SFC only
;C1A7BE:	ORA $610D  ; replaces this
;REMOVED2:	STA $613D  ; v1.0 or v1.1
;REMOVED2:	STA $610D  ; SFC only
;REMOVED3:	LDA $C1A75E,X  ; v1.0 only
;REMOVED3:	LDA $C1A75B,X  ; v1.1 only
;REMOVED3:	LDA $C1A70C,X  ; SFC only
;REMOVED4:	ORA $613E  ; v1.0 or v1.1
;REMOVED4:	ORA $610E  ; SFC only
;REMOVED5:	STA $613E  ; v1.0 or v1.1
;REMOVED5:	STA $610E  ; SFC only
	TDC  ; clear high byte of A
	SEP #$20  ; 8-bit A
C1A7C4:	LDA ($78),Y
C1A7C6:	CMP #$04
C1A7C8:	BCC preiterate
;REMOVED6:	SEC
C1A7CA:	SBC #$04
C1A7CC:	BRA iterate

preiterate:
C1A7CE:	ORA #$80

iterate:
C1A7D0:	STA $6142,Y  ; v1.0 or v1.1
;C1A7D0:	STA $6112,Y  ; SFC only
C1A7D3:	INY
C1A7D4:	CPY #$000A
C1A7D7:	BNE reflect_loop
C1A7D9:	JSR $AB43  ; v1.0 only
;C1A7D9:	JSR $AB40  ; v1.1 only
;C1A7D9:	JSR $AAF1  ; SFC only
	LDY $12
	PHY
C1A7DF: TDC
C1A7E0:	TAY
C1A7E1:	STY $1E
REPLACE2:
C1A7E3:	INY  ; these two INYs replace the LDY
C1A7E4:	INY
;C1A7E3:	LDY #$0002
C1A7E5:	LDA ($76),Y
C1A7E7:	JSR $9CB3  ; v1.0 only
;C1A7E1:	JSR $9CB0  ; v1.1 only
;C1A7E1:	JSR $9C61  ; SFC only
REPLACE3:
C1A7EA:	PLA  ; pull low byte only
;C1A7EA:	LDA $613D  ; replaces this in v1.0 or v1.1
;C1A7EA:	LDA $610D  ; replaces this in SFC
C1A7EB:	ASL A
C1A7EC:	ASL A
C1A7ED:	ASL A
C1A7EE:	ASL A
C1A7EF:	STA $12
REPLACE4:
C1A7F1:	PLA  ; now pull high byte
;C1A7F1:	LDA $613E  ; replaces this in v1.0 or v1.1
;C1A7F1:	LDA $610E  ; replaces this in SFC

org $C1BCA6  ; location in v1.0
;org $C1BCA3  ; location in v1.1
;org $C1BC54  ; location in SFC
REPLACE4:
C1BCA6:	LDA $613D  ; v1.0 or v1.1
;C1BCA6:	LDA $613E  ; replaces this
;C1BCA6:	LDA $610D  ; SFC only
;C1BCA6:	LDA $610E  ; replaces this
C1BCA9:	BEQ alternative
C1BCAB:	JSR $1A0F  ; v1.0 or v1.1
;C1BCAB:	JSR $19E7  ; SFC only
;REMOVED7:	CLC
;REMOVED8:	ADC #$04
;REMOVED9:	ORA #$80
C1BCAE:	STA $12
C1BCB0:	RTS

alternative:
REPLACE5:
C1BCB1:	LDA $613E  ; v1.0 or v1.1
;C1BCB1:	LDA $613D  ; replaces this
;C1BCB1:	LDA $610E  ; SFC only
;C1BCB1:	LDA $610D  ; replaces this
C1BCB4:	JSR $1A0F  ; v1.0 or v1.1
;C1BCB4:	JSR $19E7  ; SFC only
	CLC
	ADC #$04
	ORA #$80
C1BCBC:	STA $12
C1BCBE:	RTS