
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C12F79  ; location in v1.0
;org $C12F76  ; location in v1.1
;org $C12F51  ; location in SFC version
status_func:
C12F79:	LDA $7B78  ; v1.0 or v1.1
;C12F79:	LDA $7B48  ; SFC only
C12F7C:	AND #$03
C12F7E:	TAY
REPLACE1:
C12F7F:	LSR
C12F80:	ROR
C12F81:	ROR
C12F82:	ROR
;C12F7F:	ASL  ; replaces these five ASLs
;	ASL  ; my way is faster
;	ASL
;	ASL
;	ASL
C12F83:	TAX
C12F84:	LDA $61CD,X  ; v1.0 or v1.1
;C12F84:	LDA $619D,X  ; SFC only
C12F87:	BEQ status_update
C12F89:	JMP exit

status_update:
REPLACE2:
C12F8C:	INC
;C12F8C:	LDA #$01  ; replaces this
C12F8D:	STA $61CE,X  ; v1.0 or v1.1
;C12F8D:	STA $619E,X  ; SFC only
REPLACE3:
C12F90:	AND $2F4B
;C12F90:	LDA $2F4B  ; replaces this
;REMOVED1:	AND #$01
C12F93:	BNE check_sprite_ID
C12F95:	LDA $2EC0,X
C12F98:	AND #$08
C12F9A:	BEQ check_imp
;REMOVED2:
;	LDA $7B6C,Y  ; v1.0 or v1.1
;	LDA $7B3C,Y  ; SFC only
;	CMP #$12
;	BEQ check_vanish
C12F9C:	LDA #$12
;REMOVED3:
;	STA $7B6C,Y  ; v1.0 or v1.1
;	STA $7B3C,Y  ; SFC only
;	JSR $3157  ; v1.0 only
;	JSR $3154  ; v1.1 only
;	JSR $312F  ; SFC only
;	TDC
;	STA $7B70,Y  ; v1.0 or v1.1
;	STA $7B40,Y  ; SFC only
REPLACE4:
C12F9E:	BRA compare
;C12F9E:	BRA check_vanish

check_imp:
C12FA0:	LDA $2EBD,X
C12FA3:	AND #$20
C12FA5:	BEQ check_sprite_ID
;REMOVED4:
;	LDA $7B6C,Y  ; v1.0 or v1.1
;	LDA $7B3C,Y  ; SFC only
;	CMP #$0F
;	BEQ check_vanish
C12FA7:	LDA #$0F
;REMOVED5:
;	STA $7B6C,Y  ; v1.0 or v1.1
;	STA $7B3C,Y  ; SFC only
;	JSR $3157  ; v1.0 only
;	JSR $3154  ; v1.1 only
;	JSR $312F  ; SFC only
;	TDC
;	STA $7B70,Y  ; v1.0 or v1.1
;	STA $7B40,Y  ; SFC only
REPLACE5:
C12FA9:	BRA compare
;C12FA9:	BRA check_vanish  ; replaces this
;REMOVED6:
;	LDA $7B6C,Y  ; v1.0 or v1.1
;	LDA $7B3C,Y  ; SFC only
;	CMP $2EAE,X
;	BEQ check_vanish

check_sprite_ID:
C12FAB:	LDA $2EAE,X

compare:
	CMP $7B6C,Y  ; v1.0 or v1.1
;	CMP $7B3C,Y  ; SFC only
	BEQ check_vanish
C12FB3:	STA $7B6C,Y  ; v1.0 or v1.1
;C12FB3:	STA $7B3C,Y  ; SFC only
C12FB6:	JSR $3157  ; v1.0 only
;C12FB6:	JSR $3154  ; v1.1 only
;C12FB6:	JSR $312F  ; SFC only
C12FB9:	TDC
C12FBA:	STA $7B70,Y  ; v1.0 or v1.1
;C12FBA:	STA $7B40,Y  ; SFC only

check_vanish:
C12FBD:	LDA $2F4B
REPLACE6:
C12FC0:	LSR
C12FC1:	BCS remove_vanish
;C12FC0:	AND #$01  ; replaces these two instructions
;C12FC2:	BNE remove_vanish
C12FC3:	LDA $2EBD,X
C12FC6:	AND #$10
C12FC8:	BEQ remove_vanish
C12FCA:	LDA $7B70,Y  ; v1.0 or v1.1
;C12FCA:	LDA $7B40,Y  ; SFC only
C12FCD:	BNE other_status
C12FCF:	LDA $7B6A  ; v1.0 or v1.1
;C12FCF:	LDA $7B3A  ; SFC only
C12FD2:	BNE other_status
C12FD4:	INC $7B6A  ; v1.0 or v1.1
;C12FD4:	INC $7B3A  ; SFC only
C12FD7:	JSR vanish_move
C12FDA:	JSR $3106  ; v1.0 only
;C12FDA:	JSR $3103  ; v1.1 only
;C12FDA:	JSR $30DE  ; SFC only
C12FDD:	LDA #$01
;REMOVED7:
;	STA $7B70,Y  ; v1.0 or v1.1
;	STA $7B40,Y  ; SFC only
;	LDA #$1E
;	STA $61CD,X  ; v1.0 or v1.1
;	STA $619D,X  ; SFC only
C12FDF:	BRA after_wipe

remove_vanish:
C12FE1:	LDA $7B70,Y  ; v1.0 or v1.1
;C12FE1:	LDA $7B40,Y  ; SFC only
C12FE4:	BEQ other_status
C12FE6:	LDA $7B6A  ; v1.0 or v1.1
;C12FE6:	LDA $7B3A  ; SFC only
C12FE9:	BNE other_status
C12FEB:	INC $7B6A  ; v1.0 or v1.1
;C12FD4:	INC $7B3A  ; SFC only
C12FEE:	JSR vanish_move
C12FF1:	LDA $7B6C,Y  ; v1.0 or v1.1
;C12FF1:	LDA $7B3C,Y  ; SFC only
C12FF4:	JSR $3157  ; v1.0 only
;C12FF4:	JSR $3154  ; v1.1 only
;C12FF4:	JSR $312F  ; SFC only
C12FF7:	TDC
;REMOVED7:
;	STA $7B70,Y  ; v1.0 or v1.1
;	STA $7B40,Y  ; SFC only
;	LDA #$1E
;	STA $61CD,X  ; v1.0 or v1.1
;	STA $619D,X  ; SFC only

after_wipe:
C12FF8:	STA $7B70,Y  ; v1.0 or v1.1
;C12FF8:	STA $7B40,Y  ; SFC only
C12FFB:	LDA #$1E
C12FFD:	STA $61CD,X  ; v1.0 or v1.1
;C12FFD:	STA $619D,X  ; SFC only

other_status:
C13000:	STZ $61CE,X  ; v1.0 or v1.1
;C13000:	STZ $619E,X  ; SFC only
C13003:	JSR $3071  ; v1.0 only
;C13003:	JSR $306E  ; v1.1 only
;C13003:	JSR $3049  ; SFC only
C13006:	JSR $2F24  ; v1.0 only
;C13006:	JSR $2F21  ; v1.1 only
;C13006:	JSR $2EFC  ; SFC only
C13009:	REP #$20
C1300B:	LDA $2EBD,X
C1300E:	STA $2EC1,X
C13011:	LDA $2EBF,X
C13014:	STA $2EC3,X
C13017:	TDC
C13018:	SEP #$20
C1301A:	INC $7B78  ; v1.0 or v1.1
;C1301A:	INC $7B48  ; SFC only
C1301D:	RTS

check_magitek:
	PHA
	LDA $1A
	DEC
	AND #$0006
	BNE pull_and_compare
	LDA $7E64BA  ; v1.0 or v1.1
;	LDA $7E648A  ; SFC only
	BEQ pull_and_compare
	PLA
	SEP #$02
	RTS

pull_and_compare:
	PLA
	CMP #$FFFF
	RTS

padbyte $EA : pad $C13050  ; v1.0 only
;padbyte $EA : pad $C1304D  ; v1.1 only
;padbyte $EA : pad $C13028  ; SFC only
vanish_move:

org $C13D87  ; location in v1.0
REPLACE7:
C13D87:	JSR $301E

;org $C13D84  ; location in v1.1
;REPLACE7:
C13D84:	JSR $301B

;org $C13D5F  ; location in SFC version
;REPLACE7:
C13D5D:	JSR $2FF6

;	CMP #$FFFF  ; this is the replaced instruction in all three ROMs