
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C30247
DW equip_menu

org $C30287
DW equip_menu_remove

org $C31BE8  ; location in v1.0 or v1.1
;org $C31C4E  ; location in SFC version
C31BE8:	JSR print_equip

org $C31BF6  ; location in v1.0 or v1.1
;org $C31C5C  ; location in SFC version
C31BF6:	JSR print_remove

org $C3960C  ; location in v1.0 or v1.1
;org $C39DFB  ; location in SFC version
clear_39:
C3960C:	JSR print_spaces
C3960F:	LDY $00
C39611:	STY $39
C39613:	RTS

inc_3a:
REPLACE1:
C39614:	JSR clear_39  ; two instructions replace three
C39617:	INC $3A
;C39614:	JSR print_spaces
;C39616:	LDY #$0100
;C39617:	STY $39
C39619:	LDA #$2C
C3961B:	STA $29
C3961D:	RTS

equip_menu:
C3961E:	JSR clear_39
C39621:	JSR $904E  ; v1.0 or v1.1
;C39621:	JSR $97F7  ; SFC only
C39624:	JSR $8E56  ; v1.0 or v1.1
;C39624:	JSR $95CB  ; SFC only
C39627:	LDA $08
REPLACE2:
C39629:	BPL equip_no_a  ; one instruction replaces two
;C39629:	BIT #$80
;C3962A:	BEQ equip_no_a
C3962B:	JSR $0EB2  ; v1.0 or v1.1
;C3962B:	JSR $0F1D  ; SFC only
REPLACE3:
C3962E:	TDC  ; these five instructions replace the BRA
C3962F:	LDA $4B
C39631:	ASL A
C39632:	TAX
C39633:	JMP (equip_pointers,X)
;C3962E:	BRA equip_jump

equip_no_a:
C39636:	LDA $09
REPLACE4:
C39638:	BPL equip_no_b  ; one instruction replaces two
;C39638:	BIT #$80
;C39639:	BEQ equip_no_b
C3963A:	JSR $0EA9  ; v1.0 or v1.1
;C3963A:	JSR $0F14  ; SFC only
C3963D:	JSR $9110  ; v1.0 or v1.1
;C3963D:	JSR $98B9  ; SFC only
C39640:	LDA #$04
C39642:	STA $27
C39644:	STZ $26
C39646:	RTS

equip_no_b:
	ASL A
	BPL equip_no_y
	
to_relic:
	JSR $0EB2  ; v1.0 or v1.1
;	JSR $0F1D  ; SFC only
	LDA #$58
	STA $26
	INC $25
	RTS

equip_no_y:
C39654:	LDA #$35

check_l_r:
C39656:	STA $E0
C39658:	JMP $2022  ; v1.0 or v1.1
;C39658:	JMP $2088  ; SFC only

print_equip:
C3965B:	LDY #$A309  ; v1.0 or v1.1
;C3965B:	LDY #$AB0E  ; SFC only
;C3965B:	LDY #$5E01  ; RPGOne v1.2b only
REPLACE5:
C3965E:	BRA print  ; one replaces two
;C3965E:	JSR $02F9  ; v1.0 or v1.1
;C3965E:	JSR $0326  ; SFC only
;C3965F:	RTS

print_remove:
C39660:	LDY #$A311  ; v1.0 or v1.1
;C39660:	LDY #$AB14  ; SFC only
;C39660:	LDY #$5E09  ; RPGOne v1.2b only
REPLACE6:
C39663:	BRA print  ; one replaces two
;C39663:	JSR $02F9  ; v1.0 or v1.1
;C39663:	JSR $0326  ; SFC only
;C39664:	RTS

print_spaces:
C39665:	LDY #$A2EA  ; v1.0 or v1.1
;C39665:	LDY #$AB14  ; SFC only
;C39665:	LDY #$5E09  ; RPGOne v1.2b only
print:
REPLACE7:  ; JMP replaces JSR
C39668:	JMP $02F9  ; v1.0 or v1.1
;C39668:	JMP $0326  ; SFC only
;C39668:	JSR $02F9  ; v1.0 or v1.1
;C39668:	JSR $0326  ; SFC only
C3966B:	RTS

;REMOVED1:
;equip_jump:
;	TDC
;	LDA $4B
;	ASL A
;	TAX
;	JMP (equip_pointers,X)

equip_pointers:
DW equip_fn, optimum_fn, remove_fn, empty_fn

equip_fn:
C39674:	JSR inc_3a
C39677:	JSR print_equip

equip_finger_slots:
C3967A:	JSR $8E6C  ; v1.0 or v1.1
;C3967A:	JSR $95E1  ; SFC only
C3967D:	JSR $8E75  ; v1.0 or v1.1
;C3967D:	JSR $95EA  ; SFC only
C39680:	LDA #$55
C39682:	STA $26
C39684:	RTS

optimum_fn:
C39685:	JSR $96F0  ; v1.0 or v1.1
;C39685:	JSR $9EDF  ; SFC only

equip_refresh:
C39688:	JSR $911B  ; v1.0 or v1.1
;C39688:	JSR $98C4  ; SFC only
C3968B:	STZ $4D
C3968D:	RTS

remove_fn:
C3968E:	JSR inc_3a
C39691:	JSR print_remove
REPLACE8:
C39694:	JSR equip_finger_slots  ; two instructions replace four
C39697:	INC $26
;C39694:	JSR $8E6C  ; v1.0 or v1.1
;C39694:	JSR $95E1  ; SFC only
;C39695:	JSR $8E75  ; v1.0 or v1.1
;C39695:	JSR $95EA  ; SFC only
;C39696:	LDA #$56
;C39697:	STA $26
C39699:	RTS

empty_fn:
C3969A:	JSR empty
REPLACE9:
C3969D:	BRA equip_refresh  ; one instruction replaces two
;C3969D:	JSR $911B  ; v1.0 or v1.1
;C3969D:	JSR $98C4  ; SFC only
;C3969E:	STZ $4D

queue_equip:
	LDA #$35
	STA $26
	STZ $27
	DEC $25
C396A7:	RTS

empty:

org $C39884  ; location in v1.0 or v1.1
;org $C3A073  ; location in SFC version
C39884:	JSR $8E72  ; v1.0 or v1.1
;C39884:	JSR $95E7  ; SFC only
C39887:	JSR $9975  ; v1.0 or v1.1
;C39887:	JSR $A164  ; SFC only
C3988A:	LDA $08
REPLACE10:
C3988C:	BPL remove_no_a  ; one replaces two
;C3988C:	BIT #$80
;C3988D:	BEQ remove_no_a
C3988E:	JSR $0EB2  ; v1.0 or v1.1
;C3988E:	JSR $0F1D  ; SFC only
C39891:	LDA $4E
C39893:	STA $5F
REPLACE11:
C39895:	LDX #$5557  ; two replace two
C39898:	STX $26
;C39895:	LDA #$57
;C39898:	STA $26
C3989A:	JSR $9B59  ; v1.0 or v1.1
;C3989A:	JSR $A348  ; SFC only
C3989D:	JSR $A150  ; v1.0 or v1.1
;C3989D:	JSR $A95E  ; SFC only
C398A0:	JSR $9AEB  ; v1.0 or v1.1
;C398A0:	JSR $A2DA  ; SFC only
;REMOVED2:
;	LDA #$55
;	STA $27
C398A3:	JSR $9233  ; v1.0 or v1.1
;C398A3:	JSR $9A1C  ; SFC only
C398A6:	JSR $6A15  ; v1.0 or v1.1
;C398A6:	JSR $71A9  ; SFC only
C398A9:	JSR $1368  ; v1.0 or v1.1
;C398A9:	JSR $13D3  ; SFC only
C398AC:	JMP $9CAC  ; v1.0 or v1.1
;C398AC:	JMP $A49B  ; SFC only

remove_no_a:
C398AF:	LDA $09
REPLACE12:
C398B1:	BPL remove_no_b  ; one replaces two
;C398B1:	BIT #$80
;C398B2:	BEQ remove_no_b
C398B3:	JSR $0EA9  ; v1.0 or v1.1
;C398B3:	JSR $0F14  ; SFC only
	LDA #$36
	STA $26
C398BA:	JSR $8E50  ; v1.0 or v1.1
;C398BA:	JSR $95C5  ; SFC only
REPLACE13:  ; one JMP replaces four instructions
C398BD:	JMP $8E59  ; v1.0 or v1.1
;C398BD:	JMP $95CE  ; SFC only
;C398BD:	JSR $8E59  ; v1.0 or v1.1
;C398BD:	JSR $95CE  ; SFC only
;	LDA #$36
;	STA $26
;	RTS

remove_no_b:
	ASL A
	BPL remove_no_y
	JMP to_relic

remove_no_y:
REPLACE14:
C398C6:	LDA $26  ; three replace three
C398C8:	ADC #$29
C398CA:	JMP check_l_r
;C398C6:	LDA #$7E
;C398C8:	STA $E0
;C398CA:	JMP $2022  ; v1.0 or v1.1
;C398CA:	JMP $2088  ; SFC only

equip_menu_remove:
C398CD:	JSR $8E72  ; v1.0 or v1.1
;C398CD:	JSR $95E7  ; SFC only
C398D0:	LDA $08
REPLACE15:
C398D2:	BPL remove_no_a  ; one replaces two
;C398D2:	BIT #$80
;C398D3:	BEQ REPLACE16
C398D4:	JSR $0EB2  ; v1.0 or v1.1
;C398D4:	JSR $0F1D  ; SFC only
C398D7:	JSR $93F2  ; v1.0 or v1.1
;C398D7:	JSR $9BE1  ; SFC only
C398DA:	REP #$21
C398DC:	TYA
C398DD:	SEP #$20
C398DF:	ADC $4B
C398E1:	TAY
C398E2:	LDA $001F,Y
C398E5:	JSR $9D5E  ; v1.0 or v1.1
;C398E5:	JSR $A56C  ; SFC only
C398E8:	LDA #$FF
C398EA:	STA $001F,Y
C398ED:	JSR $911B  ; v1.0 or v1.1
;C398ED:	JSR $98C4  ; SFC only
REPLACE16:
C398F0:	BRA remove_no_a  ; one replaces nine! NINE!
;C398F0:	LDA $09
;	BIT #$80
;	BEQ relic_y
;	JSR $0EA9  ; v1.0 or v1.1
;	JSR $0F14  ; SFC only
;	JSR $8E50  ; v1.0 or v1.1
;	JSR $95C5  ; SFC only
;	JSR $8E59  ; v1.0 or v1.1
;	JSR $95CE  ; SFC only
;	LDA #$36
;	STA $26
;	RTS

relic_y:
REPLACE17:
C398F2:	LDA $09  ; FOURTEEN instructions replace those three down there
C398F4:	ASL A
C398F5:	BPL exit
C398F7:	JSR $0EB2  ; v1.0 or v1.1
;C398F7:	JSR $0F1D  ; SFC only
C398FA:	JSR $1E5F  ; v1.0 or v1.1
;C398FA:	JSR $1EC5  ; SFC only
C398FD:	BCS exit
C398FF:	JSR $9EEB  ; v1.0 or v1.1
;C398FF:	JSR $A6F9  ; SFC only
C39902:	LDA $99
C39904:	BNE exit
C39906:	JSR queue_equip
C39909:	JMP $9EE6  ; v1.0 or v1.1
;C39909:	JMP $A6F4  ; SFC only
C3990C:	NOP
C3990D:	NOP
C3990E:	NOP
;	LDA #$7F
;	STA $E0
;	JMP $2022  ; v1.0 or v1.1
;	JMP $2088  ; SFC only

org $C39E80  ; location in v1.0 or v1.1
;org $C3A68E  ; location in SFC version
C39E80:	JSR print_equip

org $C39E8E  ; location in v1.0 or v1.1
;org $C3A69C  ; location in SFC version
C39E8E:	JSR print_remove

org $C39EDC  ; location in v1.0 or v1.1
;org $C3A6EA  ; location in SFC version
REPLACE18:
C39EDC:	JSR relic_y  ; one replaces one
;C39EDC:	JSR $9EE6  ; v1.0 or v1.1
;C39EDC:	JSR $A6F4  ; SFC only

org $C39F1C  ; location in v1.0 or v1.1
;org $C3A72A  ; location in SFC version
C39F1C:	JSR print_spaces

org $C39FDE  ; location in v1.0 or v1.1
;org $C3A7EC  ; location in SFC version
C39FDE:	JSR print_equip

org $C39FEF  ; location in v1.0 or v1.1
;org $C3A7FD  ; location in SFC version
C39FEF:	JSR print_remove

org $C3A047  ; location in v1.0 or v1.1
;org $C3A855  ; location in SFC version
REPLACE19:
C3A047:	JSR relic_y  ; one replaces one
;C3A047:	JSR $9EE6  ; v1.0 or v1.1
;C3A047:	JSR $A6F4  ; SFC only

org $C3A146  ; location in v1.0 or v1.1
;org $C3A855  ; location in SFC version
REPLACE20:
C3A146:	JSR relic_y  ; one replaces one
;C3A146:	JSR $9EE6  ; v1.0 or v1.1
;C3A146:	JSR $A6F4  ; SFC only