
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C23C04  ; location in v1.0 and v1.1
;org $C23BEC  ; location in SFC version only
C23C04:	LDA $05,S
C23C06:	TAX
C23C07:	REP #$20  ; 16-bit A
	SEC
	LDA #$11AA

swap:
	STA $EE
C23C0F:	LDA $3EE4,X  ; status bytes 1-2, caster
C23C12:	AND $3EE4,Y  ; status bytes 1-2, target
C23C15:	EOR #$FFFF
	AND ($EE)
C23C1A:	STA $EE
	BCC after_heal
	JSR C265BE  ; choose healing if HP is 0
	JSR C265BE  ; do it again with entities swapped

after_heal:
	SEC

swap_status:
C23C25:	LDA $3EE4,X
C23C28:	AND $EE  ; statuses exclusive to entity 1
C23C2A:	STA $3DD4,Y  ; entity 2 status to set
C23C2D:	STA $3DFC,X  ; entity 1 status to clear

REMOVED1:
;	LDA $3EE4,Y
;	AND $EE
;	STA $3DD4,X
;	STA $3DFC,Y
;	LDA $3EF8,X
;	AND $3EF8,Y
;	EOR #$FFFF
;	STA $EE
;	LDA $3EF8,X
;	AND $EE
;	STA $3DE8,Y
;	STA $3E10,X
;	LDA $3EF8,Y
;	AND $EE
;	STA $3DE8,X
;	STA $3E10,Y
	PHX
	TYX
	PLY
	BCC iterate
	CLC
	BRA swap_status
	
iterate:
	TXA
	ADC #$0014
	TAX
	TYA
	ADC #$0014
	TAY
	LDA #$11AC
	CPX #$28
	BCC swap
	RTS
	NOP
	NOP

org $C2675D
C2675D:	REP #$20  ; 16-bit A
C2675F:	LDA $3BF4,Y  ; load target's HP
C26762:	BNE jump  ; if not 0, do nothing

org $C265BE
C265BE:	LDA $3BF4,Y  ; load entity's HP

; three different algorithms, uncomment the one you want
OPTION1:  ; heal for current HP of other entity
;C265C1:	BNE exit  ; if not 0, don't heal
;C265C3:	LDA $3BF4,X  ; load other entity's HP
;C265C6:	BEQ exit  ; if 0, don't bother
;C265C8:	STA $33E4,Y  ; heal that much

OPTION2:  ; heal 1/8 of max HP
;C265C1:	BNE exit  ; if not 0, don't heal
;C265C3:	LDA $3BF4,X  ; load other entity's HP
;C265C6:	BEQ exit  ; if 0, don't heal
;C265C8:	LDA $3C1C,Y  ; load entity's max HP
;C165CB:	LSR A
;C165CC:	LSR A
;C165CD:	LSR A  ; reduce to 1/8
;C165CE:	STA $33E4,Y  ; heal that much

OPTION3:  ; heal 1 HP
;C265C1:	BEQ exit  ; if 0, do nothing
;C265C3:	LDA $3BF4,X  ; load other entity's HP
;C265C6:	BNE exit  ; if not 0, do nothing
;C265C8:	INC $3BF4,X  ; set to 1

exit:
C265D1:	PHX
C265D2:	TYX
C265D3:	PLY  ; swap X and Y
C265D4:	RTS

org $C4736B
REPLACE1:
DB $02
;DB $03  ; replaces this byte